      program ese3
c______________________________________________________________________
c
c     Esercitazione n. 3: Approssimazione di Boussinesque
c                  
c                   
c                             L3  
c               _________________________________________
c               |                                       |
c               |                                       |
c               |                                       |
c L4            |                                       |     L2 
c               |                                       |
c               |                                       |
c           *   |                                       |
c         j |   |                                       |
c               _________________________________________
c
c                 i -*             L1 
c
c
c______________________________________________________________________
      integer*4 m
      parameter (m=101)
c
      real*8 ztn(m,m),ztv(m,m),psn(m,m),psv(m,m),thn(m,m),thv(m,m)
      real*8 u(m,m),v(m,m),f(m,m),g(m,m),b(m,m)
c
      integer*4 n,ntime
      integer*4 itout
      integer*4 it,i,j
      real*8 Dt,Dy,Dx
      real*8 Gr,Pr,Nu
      real*8 D_zita,D_theta,alpha
      real*8 ps_tilde
      real*8 eps,e,emax
      real*8 t
c______________________________________________________________________
c
c     Input
c
      call input(alpha,Gr,Pr,Dt,ntime,itout,n,eps)
c
c     Parametri discretizzazione
c
      Dx = 1.d0/dfloat(n-1)
      Dy = Dx
c
      D_zita   = Dt/Dx**2 
      D_theta  = Dt/Dx**2
c
      if(Gr .gt. 0) then
         D_zita   = 1.d0/sqrt(Gr)     *Dt/Dx**2 
         D_theta  = 1.d0/(Pr*sqrt(Gr))*Dt/Dx**2
      end if
c
      if((D_zita .gt. .25) .or. (D_theta .gt. .25)) then
        write(*,*) 'Condizione di stab. violata'
        stop
      end if
c
c     Assegnazione Condizioni Iniziali ed Inizializzazione
c
      do 100 j=1,n
         do 200 i=1,n
            ztn(i,j)  = 0.d0
            ztv(i,j)  = 0.d0
            psn(i,j) = 0.d0
            psv(i,j) = 0.d0
            thn(i,j)  = 0.d0
            thv(i,j)  = 0.d0
            u(i,j)    = 0.d0
            v(i,j)    = 0.d0
            f(i,j)    = 0.d0
            g(i,j)    = 0.d0
            b(i,j)    = 0.d0
200      continue 
100   continue 
c
c     Apertura unita' di output
c
C      call output(0,it,t,psn,thn,ztn,u,v,n,m)
C      call tecout(0,it,t,Dx,Dy,psn,thn,ztn,u,v,n,m)
      call excelout(0,it,t,Dx,Dy,psn,thn,ztn,u,v,n,m) 
c
c     Ciclo temporale: Inizio
c
      do 300 it=1,ntime
         t = it*Dt
c
c       Condizioni al contorno
c       
         do 400 i=2,n-1
c           Lato1 
            psv(i,1) = 0.d0
            ztv(i,1) = 2.d0*(psv(i,1) - psv(i,2))/dy**2
            thv(i,1) = thv(i,2)
            psn(i,1) = 0.d0
            ztn(i,1) = 2.d0*(psv(i,1) - psv(i,2))/dy**2
            thn(i,1) = thv(i,2)
            u(i,1)   = 0.d0
            v(i,1)   = 0.d0
c           Lato2 
            psv(n,i) = 0.d0
            ztv(n,i) = 2.d0*(psv(n,i) - psv(n-1,i))/dx**2
            thv(n,i) = 1.d0
            psn(n,i) = 0.d0
            ztn(n,i) = 2.d0*(psv(n,i) - psv(n-1,i))/dx**2
            thn(n,i) = 1.d0
            u(n,i)   = 0.d0
            v(n,i)   = 0.d0
c           Lato3 
            psv(i,n) = 0.d0
            ztv(i,n) = 2.d0*(psv(i,n) - psv(i,n-1))/dy**2
            thv(i,n) = thv(i,n-1)
            psn(i,n) = 0.d0
            ztn(i,n) = 2.d0*(psv(i,n) - psv(i,n-1))/dy**2
            thn(i,n) = thv(i,n-1)
            u(i,n)   = 0.d0
            v(i,n)   = 0.d0
c           Lato4 
            psv(1,i) = 0.d0
            ztv(1,i) = 2.d0*(psv(1,i) - psv(2,i))/dx**2
            thv(1,i) = 0.d0
            psn(1,i) = 0.d0
            ztn(1,i) = 2.d0*(psv(1,i) - psv(2,i))/dx**2
            thn(1,i) = 0.d0
            u(1,i)   = 0.d0
            v(1,i)   = 0.d0 
400      continue
c
c        Estremi lato 2
c
         thv(n,1) = 1.d0
         thv(n,n) = 1.d0
         thn(n,1) = 1.d0
         thn(n,n) = 1.d0
c
c        Calcolo velocita'
c
         do 500 j=2,n-1
            do 600 i=2,n-1
               u(i,j) =  (psv(i,j+1) - psv(i,j-1))/(2.d0*dy)
               v(i,j) = -(psv(i+1,j) - psv(i-1,j))/(2.d0*dx)
600         continue
500      continue
c
c        Calcolo termini convettivi e galleggiamento
c
         if(Gr .gt. 0)  then
            do 700 j=2,n-1
               do 800 i=2,n-1
                  f(i,j) = -( u(i,j)*(ztv(i+1,j)-ztv(i-1,j))/(2.d0*dx) + 
     &                        v(i,j)*(ztv(i,j+1)-ztv(i,j-1))/(2.d0*dy) )
                  g(i,j) = -( u(i,j)*(thv(i+1,j)-thv(i-1,j))/(2.d0*dx) + 
     &                        v(i,j)*(thv(i,j+1)-thv(i,j-1))/(2.d0*dy) )
800            continue
700         continue
         end if
c
c        Calcolo Termine galleggiamento
c
         do 750 j=2,n-1
            do 850 i=2,n-1
               b(i,j) = (thv(i+1,j)-thv(i-1,j))/(2.d0*dx)
850         continue
750      continue
c
c        Soluzioni nuovo passo
c
         do 900 j=2,n-1
            do 1000 i=2,n-1
                   ztn(i,j) = ztv(i,j) + D_zita*(
     &                        ztv(i-1,j)+ztv(i+1,j)+
     &                        ztv(i,j-1)+ztv(i,j+1)-
     &                        4.d0*ztv(i,j) ) + (f(i,j) + b(i,j))*Dt
c
                   thn(i,j) = thv(i,j) + D_theta*(
     &                        thv(i-1,j)+thv(i+1,j)+
     &                        thv(i,j-1)+thv(i,j+1)-
     &                        4.d0*thv(i,j) ) + g(i,j)*Dt
c
                   ps_tilde = .25d0*(psv(i+1,j) + psv(i-1,j) + 
     &                               psv(i,j-1) + psv(i,j+1) + 
     &                               ztv(i,j)*dx**2)
                   psn(i,j) = (1.d0 - alpha)*psv(i,j) + alpha*ps_tilde
c
1000        continue
900      continue
c
c        Controllo convergenza
c
         emax = 0.d0
         do 1100 j=2,n-1
            do 1200 i=2,n-1
               e = abs( ztn(i,j) - ztv(i,j) ) / Dt 
               if(e .gt. emax) emax = e
1200        continue
1100     continue
c
c        Aggiornamento 
c
         do 1300 j=2,n-1
            do 1400 i=2,n-1
               psv(i,j) = psn(i,j)
               ztv(i,j) = ztn(i,j)
               thv(i,j) = thn(i,j)
1400        continue
1300     continue
c
c        Output
c
         if( (emax .lt. eps) .or. (it/itout*itout .eq. it) ) then
CC          call output(1,it,t,psn,thn,ztn,u,v,n,m) 
CC          call tecout(1,it,t,Dx,Dy,psn,thn,ztn,u,v,n,m) 
            write(*,*) 'it = ',it,' emax = ',emax
         end if
         if(emax .lt. eps) then
            write(*,*) 'Soluzione stazionaria it = ',it
C            call output(1,it,t,psn,thn,ztn,u,v,n,m) 
C            call tecout(1,it,t,Dx,Dy,psn,thn,ztn,u,v,n,m)
            call excelout(1,it,t,Dx,Dy,psn,thn,ztn,u,v,n,m) 
            call Nusselt(m,n,Dx,Dy,thn,Gr,Nu)
            stop
         end if
c
c        Ciclo temporale: Fine
c
300   continue
c
c     Chiusura unita' di output
c
C      call output(2,it,t,psn,thn,ztn,u,v,n,m) 
C      call tecout(2,it,t,Dx,Dy,psn,thn,ztn,u,v,n,m)
      call excelout(2,it,t,Dx,Dy,psn,thn,ztn,u,v,n,m) 
c______________________________________________________________________
      end
c______________________________________________________________________
c______________________________________________________________________
      subroutine output(iclose,it,t,psn,thn,ztn,u,v,n,m) 
c______________________________________________________________________
c
c     Output:
c
c             iclose = 0: apre unita' 1
c             iclose = 1: stampa su unita' 1
c             iclose = 2: chiude unita' 1
c
c______________________________________________________________________
      integer*4 iclose,it,n,m
      real*8 t
      real*8 psn(m,m),thn(m,m),ztn(m,m),u(m,m),v(m,m)
c
      integer*4 i,j
c
c     Aree common:
      include 'addr.inc'
c______________________________________________________________________
      filen = ' ese3.out'
      call sver()
      call strg()
      if(iclose .eq. 0) then
        open(unit=1,file=opfile)
      end if
      if(iclose .eq. 2) then
        close(unit=1)
      end if
      if(iclose .eq. 1) then
         write(1,1000) it,t
c
         write(1,1101) 
         do 100 i=1,n
            write(1,1200) (psn(i,j),j=1,n)
100      continue
c
         write(1,1102) 
         do 200 i=1,n
            write(1,1200) (thn(i,j),j=1,n)
200      continue
c
         write(1,1103) 
         do 300 i=1,n
            write(1,1200) (ztn(i,j),j=1,n)
300      continue
c
         write(1,1104) 
         do 400 i=1,n
            write(1,1200) (u(i,j),j=1,n)
400      continue
c
         write(1,1105) 
         do 500 i=1,n
            write(1,1200) (v(i,j),j=1,n)
500      continue
      end if
c
c     Formats
c
1000  format(1x/1x,'it = ',i5.5,'t = ',g11.5/)
1101  format(1x/1x,'Funzione di Corrente PSN')
1102  format(1x/1x,'Temperatura THN')
1103  format(1x/1x,'Vorticita ZTN')
1104  format(1x/1x,'Componente orizzontale velocita U')
1105  format(1x/1x,'Componente verticale velocita V')
1200  format(11(1x,g11.5))
c______________________________________________________________________
      end
c______________________________________________________________________
c______________________________________________________________________
      subroutine input(alpha,Gr,Pr,Dt,ntime,itout,n,eps)
c______________________________________________________________________
c
c     Input
c
c______________________________________________________________________
      integer*4 ntime,itout,n
      real*8 ni,DT,eps,Gr,Pr,alpha
c
c     Aree common:
      include 'addr.inc'
c______________________________________________________________________
c
c     Input
c
      open(unit=1,file='ese3.dat')
         read(1,*) ver
         read(1,*) path1
         read(1,*) path2
         read(1,*) alpha
         read(1,*) Gr
         read(1,*) Pr
         read(1,*) Dt
         read(1,*) ntime
         read(1,*) itout
         read(1,*) n
         read(1,*) eps
      close(1)
c______________________________________________________________________
      end
c______________________________________________________________________
c______________________________________________________________________
      subroutine tecout(iclose,it,t,Dx,Dy,psn,thn,ztn,u,v,n,m) 
c______________________________________________________________________
c
c     Output per Tecplot
c
c______________________________________________________________________
      integer*4 iclose,it,n,m
      real*8 t,Dx,Dy
      real*8 psn(m,m),thn(m,m),ztn(m,m),u(m,m),v(m,m)
c
      character*52 tcpstr
c
      integer*4 i,j
      real*8 x,y
c
c     Aree common:
      include 'addr.inc'
c______________________________________________________________________
      filen = ' ese3tc.dat'
      call sver()
      call strg()
      if(iclose .eq. 0) then
        open(unit=2,file=opfile)
        write(2,*) 'VARIABLES = "x","y","psn","thn","ztn","u","v" '
      end if
      if(iclose .eq. 2) then
        close(unit=2)
      end if
      if(iclose .eq. 1) then
         tcpstr = 'ZONE I=     J=    '
         write(tcpstr( 8:11),1000) n
         write(tcpstr(15:18),1000) n
         write(2,*) tcpstr
         do 100 j=1,n
            y = (j-1)*Dy
            do 200 i=1,n
               x = (i-1)*Dx
               write(2,*) x,y,psn(i,j),thn(i,j),ztn(i,j),u(i,j),v(i,j)
200         continue
100      continue
      end if
c
1000  format(i4.4)
c______________________________________________________________________
      end
c______________________________________________________________________
c______________________________________________________________________
      subroutine excelout(iclose,it,t,Dx,Dy,psn,thn,ztn,u,v,n,m) 
c______________________________________________________________________
c
c     Output:
c
c             iclose = 0: apre unita' 1
c             iclose = 1: stampa su unita' 1
c             iclose = 2: chiude unita' 1
c
c______________________________________________________________________
      integer*4 iclose,it,n,m
      real*8 t,Dx,Dy
      real*8 psn(m,m),thn(m,m),ztn(m,m),u(m,m),v(m,m)
c
      integer*4 i,j
      character*21 fmt
c
c     Aree common:
      include 'addr.inc'
c______________________________________________________________________
      filen = ' excel.out'
      call sver()
      call strg()
      if(iclose .eq. 0) then
        open(unit=21,file=opfile)
      end if
      if(iclose .eq. 2) then
        close(unit=21)
      end if
      if(iclose .eq. 1) then
         write(21,1000) it,t
c
         fmt = '(???(1x,f11.5))'
         write(fmt(2:4),1300) n
1300     format(i3.3)
c
         write(21,1101) 
         do 100 j=1,n
            write(21,fmt) (psn(i,j),i=1,n)
100      continue
c
         write(21,1102) 
         do 200 j=1,n
            write(21,fmt) (thn(i,j),i=1,n)
200      continue
c
         write(21,1103) 
         do 300 j=1,n
            write(21,fmt) (ztn(i,j),i=1,n)
300      continue
c
         write(21,1104) 
         do 400 j=1,n
            write(21,fmt) (u(i,j),i=1,n)
400      continue
c
         write(21,1105) 
         do 500 j=1,n
            write(21,fmt) (v(i,j),i=1,n)
500      continue
      end if
c
c     Formats
c
1000  format(1x/1x,'it = ',i5.5,'t = ',g11.5/)
1101  format(1x/1x,'Funzione di Corrente PSN')
1102  format(1x/1x,'Temperatura THN')
1103  format(1x/1x,'Vorticita ZTN')
1104  format(1x/1x,'Componente orizzontale velocita U')
1105  format(1x/1x,'Componente verticale velocita V')
1200  format(5(1x,g11.5))
c______________________________________________________________________
      end

      subroutine Nusselt(m,n,Dx,Dy,thn,Gr,Nu)
c______________________________________________________________________
c
c     Calcolo Numero di Nusselt
c  
c______________________________________________________________________
      integer*4 m,n,j
      real*8 thn(m,m)
      real*8 Dx,Dy
      real*8 Nu,Gr
c______________________________________________________________________
      Nu = 0.d0
      Nu = Nu + (thn(n,1) - thn(n-1,1))*Dy/Dx*.5d0
      do 100 j=2,n-1
         Nu = Nu + (thn(n,j) - thn(n-1,j))*Dy/Dx
100   continue
      Nu = Nu + (thn(n,n) - thn(n-1,n))*Dy/Dx*.5d0
c
      write(*,*) 'Gr = ',Gr,' Nu = ',Nu
c______________________________________________________________________
      end
c______________________________________________________________________
c______________________________________________________________________
      subroutine strg()
c______________________________________________________________________
c
c     effettua la concatenazione di stringhe
c
c     opfile = path1 + path2 + filen
c
c______________________________________________________________________
c     Aree common:
      include 'addr.inc'
      character*1 ctrl
c
      integer*4 lp1,lp2,lp3,np1,np2,np3,ni,nf,ic
c
      data np1, np2, np3/ 32, 32, 32/
c______________________________________________________________________
c
      opfile = ' '
c
      do 100 ic=np1,0,-1
         lp1 = ic
         write(ctrl(1:1),1000) path1(ic:ic)
         if(ctrl .ne. ' ') go to 101
100   continue
101   continue
c
      do 200 ic=np2,0,-1
         lp2 = ic
         write(ctrl(1:1),1000) path2(ic:ic)
         if(ctrl .ne. ' ') go to 201
200   continue
201   continue
c
      do 300 ic=np3,0,-1
         lp3 = ic
         write(ctrl(1:1),1000) filen(ic:ic)
         if(ctrl .ne. ' ') go to 301
300   continue
301   continue
c
      ni = 1
      nf = lp1
      write(opfile(ni:nf),1000) path1(1:lp1)
      ni = lp1 + 1
      nf = lp1 + lp2
      write(opfile(ni:nf),1000) path2(1:lp2)
      ni = lp1 + lp2 + 1
      nf = lp1 + lp2 + lp3
      write(opfile(ni:nf),1000) filen(1:lp3)
c
1000  format(a)
c______________________________________________________________________
      end
c______________________________________________________________________
c______________________________________________________________________
      subroutine sver()
c______________________________________________________________________
c 
c     Concatena ver con filen
c
c______________________________________________________________________
c
c     Aree Common:
      include 'addr.inc'
c______________________________________________________________________
      write(filen(1:1),1000) ver
1000  format(a)
c______________________________________________________________________
      end


